"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class DOMListener extends _react.default.Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), _defineProperty(this, "state", {
      options: false
    }), _temp;
  }

  static getDerivedStateFromProps(nextProps, prevState) {
    const capture = nextProps.capture,
          once = nextProps.once,
          passive = nextProps.passive;

    if (once !== undefined || passive !== undefined) {
      return {
        options: {
          capture,
          once,
          passive
        }
      };
    }

    return {
      options: !!capture
    };
  }

  componentDidMount() {
    const _this$props = this.props,
          listener = _this$props.listener,
          target = _this$props.target,
          type = _this$props.type; // eslint-disable-next-line flowtype/no-weak-types

    target.addEventListener(type, listener, this.state.options);
  }

  componentWillUnmount() {
    const _this$props2 = this.props,
          listener = _this$props2.listener,
          target = _this$props2.target,
          type = _this$props2.type; // eslint-disable-next-line flowtype/no-weak-types

    target.removeEventListener(type, listener, this.state.options);
  }

  render() {
    return null;
  }

}

exports.default = DOMListener;